<style scoped lang="less">
    @import "../styles/expose.less";
</style>
    
<template>
    
    <Layout class="expose">
        
        <Header class="header" theme="light">
            <Menu mode="horizontal" theme="light" active-name="1">
                <img class="layout-logo" src="../images/flatflow-logo.png" alt="FlatFlow Logo">
                
                <div class="layout-nav">
                    <MenuItem name="1">
                        <Icon type="ios-navigate"></Icon>
                        Item 1
                    </MenuItem>
                    <MenuItem name="2">
                        <Icon type="ios-keypad"></Icon>
                        Item 2
                    </MenuItem>
                    <MenuItem name="3">
                        <Icon type="ios-analytics"></Icon>
                        Item 3
                    </MenuItem>
                    <MenuItem name="4">
                        <Icon type="ios-paper"></Icon>
                        Item 4
                    </MenuItem>
                </div>
            </Menu>
        </Header>
        
        <Content>
            
            <Layout style="max-width: 1100px; margin: 0 auto;">
                
                <Row :gutter="30">
                    <Col span="18">
                    
                        <Content class="content">
                            
                            <Button :style="{ 'padding-left': 0 }" :to="'/stadt/' + $route.params.cityId" icon="ios-arrow-back" type="text">Zurück zu den Ergebnissen</Button>
                        
                            <Carousel style="margin-bottom: 30px;" v-if="apartment && apartment.images && apartment.images.length > 1" :dots="gallerySettings.dots" :radius-dot="gallerySettings.radiusDot" :trigger="gallerySettings.trigger" :arrow="gallerySettings.arrow">
                                
                                <CarouselItem v-for="image of apartment.images" :key="image._id">
                                    
                                    <div style="position: relative; min-height: 500px; background-position: 50% 50%; background-repeat: no-repeat;background-size: cover; }" v-lazy:background-image="image.url" class="image">
                                        
                                        <span v-if="image.caption" style="position: absolute; bottom: 0; left: 0; right: 0; padding: 10px 20px; background: rgba(255, 255, 255, 0.8)" class="truncate">{{ image.caption}}</span>
                                        
                                    </div>
                                    
                                </CarouselItem>
                                
                            </Carousel>
                            
                            <span>{{ apartment.providerId }}</span>
                            <h1 style="margin-bottom: 30px;">{{ apartment.title }}</h1>
                            
                            <h2 v-if="apartment && apartment.features && apartment.features.length">Ausstattung</h2>
                            <ul class="features" style="margin-bottom: 30px;" v-if="apartment && apartment.features && apartment.features.length">
                                <li style="display: inline-block" v-for="feature of apartment.features">
                                    <Tag>{{feature}}</Tag>
                                </li>
                            </ul>
                            
                            <h2 v-if="apartment.description">Beschreibung</h2>
                            <p style="font-size: 16px; margin-bottom: 30px;" v-if="apartment.description">
                                {{ apartment.description }}
                            </p>
                            
                            <h2>Lage</h2>
                            
                                <Alert show-icon closable>
                                    Hinweis zur Lage
                                    <span slot="desc">Wir versuchen die Lage der Wohnung anhand der Informationen des jeweiligen Anbieters nach bestem Gewissen zu ermitteln, es kann jedoch sein, dass die Lage nicht stimmt und total für die Füße ist. Für eine genaue Adresse bitten darum direkt eine Nachricht an den Herausgeber des Inserates zu senden.</span>
                                </Alert>
                            
                            <GmapMap class="map" :center="map.options.center" :options="map.options">
                                
                                <gmap-custom-marker
                                    v-if="apartment.location && apartment.location.lat && apartment.location.lng"
                                    :key="1"
                                    :marker=" { latitude: parseFloat(apartment.location.lat), longitude: parseFloat(apartment.location.lng)}"
                                    :clickable="true"
                                    @click="center={lat: parseFloat(apartment.location.lat), lng: parseFloat(apartment.location.lng)}">
                                    
                                    <Icon :id="'apartment-' + apartment._id" v-if="apartment.location.houseNumber" type="ios-pin" size="50" color="#46AEDE"/>
                                    
                                    <Icon :id="'apartment-' + apartment._id" v-if="!apartment.location.houseNumber" type="ios-disc-outline" size="60" color="#46AEDE" :style="{ opacity: .75 }" />
                                    
                                </gmap-custom-marker>
                                
                            </GmapMap>
                            
                        </Content>
                            
                    </Col>
                    
                    <Col span="6" style="margin-top: 60px">
                    
                        <Affix :offset-top="110">
                            
                            <Card class="sidebar" :padding=0>
                                
                                <ul>
                                    <li>
                                        <span>Zimmer</span>
                                        {{ apartment.rooms }} Zimmer
                                    </li>
                                    <li>
                                        <span>Größe</span>
                                        {{ apartment.size }} Quadratmeter
                                    </li>
                                    <li v-if="apartment.price && apartment.price.cold">
                                        <span>Kaltmiete</span>
                                        {{ apartment.price.cold }}€
                                    </li>
                                    <li v-if="apartment.price && apartment.price.utilities">
                                        <span>Nebenkosten</span>
                                        {{ apartment.price.utilities}}€
                                    </li>
                                    <li v-if="apartment.price && apartment.price.total">
                                        <span>Warmmiete</span>
                                        {{ apartment.price.total }}€
                                    </li>
                                </ul>
                                
                                <div class="button-wrapper">
                                
                                    <Button :to="apartment.link" long size="large" type="primary">Zum Anbieter</Button>
                                    
                                    <span>{{ apartment.providerId }}</span>
                                    
                                </div>
                                
                            </Card>
                            
                        </Affix>
                    
                    </Col>
                    
                </Row>
            
            </Layout>
            
        </Content>
        
    </Layout>
    
</template>

<script>
    import Vue from 'vue';
    import axios from 'axios';
    import * as VueGoogleMaps from 'vue2-google-maps';
    import GmapCustomMarker from 'vue2-gmap-custom-marker';
    import VueLazyload from 'vue-lazyload';
    import config from './../config/config';
    
    Vue.use(VueGoogleMaps, {
        load: {
            key: config.googleMapsApiKey,
        },
        installComponents: true,
    });
    
    Vue.use(VueLazyload);
    
    export default {
        components: {
            GmapCustomMarker
        },
        data() {
            return {
                apartment: {},
                gallerySettings: {
                    autoplay: false,
                    autoplaySpeed: 2000,
                    dots: 'outside',
                    radiusDot: true,
                    arrow: 'always'
                },
                map: { 
                    options: {
                        center: {lat: 51.95800023, lng: 7.61970188},
                        zoom: 13,
                        zoomControl: true, 
                        mapTypeControl: false, 
                        streetViewControl: false, 
                        fullscreenControl: false,
                        styles: []
                    }
                },
            }
        },
        methods: {
            doStuff (isActive) {
                // ...
            }
        },
        created() {
           this.$Loading.start();
            
            let filter = {
                params: {
                    id: this.$route.params.apartmentId,
                }
            };
            
            axios.get(`${config.apiUrl}/apartment`, filter)
            .then(response => {
                this.apartment = response.data;
                
                if (response.data.location.lat && response.data.location.lng) {
                    this.map.options.center.lat = parseFloat(response.data.location.lat);
                    this.map.options.center.lng = parseFloat(response.data.location.lng);
                }
                
                this.$Loading.finish();
            })
            .catch(e => {
                this.$Loading.error();
                this.errors.push(e)
            });
        }
    }
</script>
